Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,5 +44,4 @@
 /** =========== define the function ====================== */
 Action::state_ptr AnalysisPairCorrelationAction::performCall() {
-  int ranges[3] = {1, 1, 1};
   ofstream output;
   ofstream binoutput;
@@ -51,16 +50,16 @@
 
   // execute action
-  output.open(params.outputname.string().c_str());
-  binoutput.open(params.binoutputname.string().c_str());
+  output.open(params.outputname.get().string().c_str());
+  binoutput.open(params.binoutputname.get().string().c_str());
   PairCorrelationMap *correlationmap = NULL;
-  ASSERT(params.elements.size() == 2,
+  ASSERT(params.elements.get().size() == 2,
       "AnalysisPairCorrelationAction::performCall() - Exactly two elements are required for pair correlation.");
-  std::vector<const element *>::const_iterator elemiter = params.elements.begin();
+  std::vector<const element *>::const_iterator elemiter = params.elements.get().begin();
   const World::AtomComposite atoms_first = World::getInstance().getAllAtoms(AtomByType(*(elemiter++)));
   const World::AtomComposite atoms_second = World::getInstance().getAllAtoms(AtomByType(*(elemiter++)));
-  ASSERT(elemiter == params.elements.end(),
+  ASSERT(elemiter == params.elements.get().end(),
       "AnalysisPairCorrelationAction::performCall() - Exactly two elements are required for pair correlation.");
-  double max_distance = params.BinEnd;
-  if (params.BinEnd <= 0.) {
+  double max_distance = params.BinEnd.get();
+  if (params.BinEnd.get() <= 0.) {
     // find max distance within box from diagonal
     const RealSpaceMatrix &M = World::getInstance().getDomain().getM();
@@ -69,5 +68,5 @@
   correlationmap = PairCorrelation(atoms_first, atoms_second, max_distance);
   OutputCorrelationMap<PairCorrelationMap>(&output, correlationmap, OutputPairCorrelation_Header, OutputPairCorrelation_Value);
-  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
+  binmap = BinData( correlationmap, params.BinWidth.get(), params.BinStart.get(), params.BinEnd.get() );
   OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
   delete(binmap);
Index: src/Actions/AnalysisAction/PairCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/PairCorrelationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,12 +11,29 @@
 class element;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::vector<const element *>)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (elements)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("elements")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("set of elements")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.5))(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(false))
+#define paramvalids \
+(STLVectorValidator< std::vector<const element *> >(2,2, ElementValidator())) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(!FilePresentValidator()) \
+(!FilePresentValidator()) \
+(DummyValidator<bool>())
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -50,17 +50,17 @@
 
   // execute action
-  output.open(params.outputname.string().c_str());
-  binoutput.open(params.binoutputname.string().c_str());
-  cout << "Point to correlate to is  " << params.Point << endl;
+  output.open(params.outputname.get().string().c_str());
+  binoutput.open(params.binoutputname.get().string().c_str());
+  cout << "Point to correlate to is  " << params.Point.get() << endl;
   CorrelationToPointMap *correlationmap = NULL;
-  for(std::vector<const element *>::iterator iter = params.elements.begin(); iter != params.elements.end(); ++iter)
+  for(std::vector<const element *>::const_iterator iter = params.elements.get().begin(); iter != params.elements.get().end(); ++iter)
     cout << "element is " << (*iter)->getSymbol() << endl;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
-  if (params.periodic)
-    correlationmap  = PeriodicCorrelationToPoint(molecules, params.elements, &params.Point, ranges);
+  if (params.periodic.get())
+    correlationmap  = PeriodicCorrelationToPoint(molecules, params.elements.get(), &params.Point.get(), ranges);
   else
-    correlationmap = CorrelationToPoint(molecules, params.elements, &params.Point);
+    correlationmap = CorrelationToPoint(molecules, params.elements.get(), &params.Point.get());
   OutputCorrelationMap<CorrelationToPointMap>(&output, correlationmap, OutputCorrelationToPoint_Header, OutputCorrelationToPoint_Value);
-  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
+  binmap = BinData( correlationmap, params.BinWidth.get(), params.BinStart.get(), params.BinEnd.get() );
   OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
   delete(binmap);
Index: src/Actions/AnalysisAction/PointCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/PointCorrelationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -13,12 +13,29 @@
 class element;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::vector<const element *>)(Vector)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (elements)(Point)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("elements")("position")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("set of elements")("position in R^3 space")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
-#define paramdefaults (NODEFAULT)(NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.5))(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(false))
+#define paramvalids \
+(STLVectorValidator< std::vector<const element *> >(ElementValidator())) \
+(BoxVectorValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(!FilePresentValidator()) \
+(!FilePresentValidator()) \
+(DummyValidator<bool>())
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.def
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
@@ -18,4 +20,5 @@
 #undef paramdescriptions
 #undef paramdefaults
+#undef paramvalids
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -53,31 +53,39 @@
 
   // execute action
-  output.open(params.outputname.string().c_str());
-  binoutput.open(params.binoutputname.string().c_str());
-  molecule *surfacemol = const_cast<molecule *>(params.Boundary);
-  ASSERT(surfacemol != NULL, "No molecule specified for SurfaceCorrelation.");
+  output.open(params.outputname.get().string().c_str());
+  binoutput.open(params.binoutputname.get().string().c_str());
+
+  // check for selected molecules and create surfaces from them
+  std::vector<atom *> atoms(World::getInstance().getSelectedAtoms());
+  LinkedCell_deprecated * LCList = NULL;
+  Tesselation * TesselStruct = NULL;
   const double radius = 4.;
   double LCWidth = 20.;
-  if (params.BinEnd > 0) {
-    if (params.BinEnd > 2.*radius)
-      LCWidth = params.BinEnd;
+  if (params.BinEnd.get() > 0) {
+    if (params.BinEnd.get() > 2.*radius)
+      LCWidth = params.BinEnd.get();
     else
       LCWidth = 2.*radius;
   }
+  if ( atoms.size() == 0) {
+    ELOG(1, "You have not select any atoms.");
+    return Action::failure;
+  }
+  // create adaptor for the selected atoms
+  PointCloudAdaptor< std::vector<atom *> > cloud(&atoms, std::string("Selected atoms"));
 
-  // get the boundary
-  class Tesselation *TesselStruct = NULL;
-  const LinkedCell_deprecated *LCList = NULL;
-  // find biggest molecule
+  // create tesselation
+  LCList = new LinkedCell_deprecated(cloud, 2.*radius);
+  TesselStruct = new Tesselation;
+  (*TesselStruct)(cloud, radius);
+
+  // correlate
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
   std::cout << "There are " << molecules.size() << " selected molecules." << std::endl;
-  PointCloudAdaptor<molecule> cloud(surfacemol, surfacemol->name);
-  LCList = new LinkedCell_deprecated(cloud, LCWidth);
-  FindNonConvexBorder(surfacemol, TesselStruct, LCList, radius, NULL);
   CorrelationToSurfaceMap *surfacemap = NULL;
-  if (params.periodic)
-    surfacemap = PeriodicCorrelationToSurface( molecules, params.elements, TesselStruct, LCList, ranges);
+  if (params.periodic.get())
+    surfacemap = PeriodicCorrelationToSurface( molecules, params.elements.get(), TesselStruct, LCList, ranges);
   else
-    surfacemap = CorrelationToSurface( molecules, params.elements, TesselStruct, LCList);
+    surfacemap = CorrelationToSurface( molecules, params.elements.get(), TesselStruct, LCList);
   delete LCList;
   OutputCorrelationMap<CorrelationToSurfaceMap>(&output, surfacemap, OutputCorrelationToSurface_Header, OutputCorrelationToSurface_Value);
@@ -89,5 +97,5 @@
       ELOG(1, "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << ".");
   }
-  binmap = BinData( surfacemap, params.BinWidth, params.BinStart, params.BinEnd );
+  binmap = BinData( surfacemap, params.BinWidth.get(), params.BinStart.get(), params.BinEnd.get() );
   OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
   delete TesselStruct;  // surfacemap contains refs to triangles! delete here, not earlier!
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -12,12 +12,27 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::vector<const element *>)(const molecule *)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
-#define paramreferences (elements)(Boundary)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
-#define paramtokens ("elements")("molecule-by-id")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
-#define paramdescriptions ("set of elements")("index of a molecule")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
-#define paramdefaults (NODEFAULT)(NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::vector<const element *>)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
+#define paramreferences (elements)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
+#define paramtokens ("elements")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
+#define paramdescriptions ("set of elements")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.5))(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(false))
+#define paramvalids \
+(STLVectorValidator< std::vector<const element *> >(ElementValidator())) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(!FilePresentValidator()) \
+(!FilePresentValidator()) \
+(DummyValidator<bool>())
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/AddAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -43,6 +43,6 @@
   // execute action
   atom * first = World::getInstance().createAtom();
-  first->setType(params.elemental);
-  first->setPosition(params.position);
+  first->setType(params.elemental.get());
+  first->setPosition(params.position.get());
   LOG(1, "Adding new atom with element " << first->getType()->getName() << " at " << (first->getPosition()) << ".");
   // TODO: remove when all of World's atoms are stored.
@@ -68,7 +68,7 @@
 
   atom * first = World::getInstance().createAtom();
-  first->setType(state->params.elemental);
-  first->setPosition(state->params.position);
-  LOG(1, "Re-adding new atom with element " << state->params.elemental->getName() << " at " << state->params.position << ".");
+  first->setType(state->params.elemental.get());
+  first->setPosition(state->params.position.get());
+  LOG(1, "Re-adding new atom with element " << state->params.elemental.get()->getName() << " at " << state->params.position.get() << ".");
   // TODO: remove when all of World's atoms are stored.
   std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
Index: src/Actions/AtomAction/AddAction.def
===================================================================
--- src/Actions/AtomAction/AddAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/AddAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,16 +7,23 @@
 
 // all includes and forward declarations necessary for non-integral types below
-#include "LinearAlgebra/BoxVector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 class element;
 
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (const element *)(BoxVector)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+//#define paramtypes (const element *)(BoxVector) TODO: use a validator
+#define paramtypes (const element *)(Vector)
 #define paramtokens ("add-atom")("domain-position")
 #define paramdescriptions ("element of new atom")("position within current domain")
 #define paramreferences (elemental)(position)
-#define paramdefaults (NODEFAULT)(NODEFAULT)
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)
+#define paramvalids \
+(ElementValidator()) \
+(BoxVectorValidator())
 
 #define statetypes (const atomId_t)
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -54,8 +54,8 @@
   for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
     first = iter->second;
-    LOG(1, "Changing atom " << *first << " to element " << *params.elemental << ".");
+    LOG(1, "Changing atom " << *first << " to element " << *params.elemental.get() << ".");
     mol = first->getMolecule();
     first->removeFromMolecule(); // remove atom
-    first->setType(params.elemental);
+    first->setType(params.elemental.get());
     mol->AddAtom(first);  // add atom to ensure correctness of formula
   }
@@ -88,5 +88,5 @@
     mol = first->getMolecule();
     first->removeFromMolecule(); // remove atom
-    first->setType(state->params.elemental);
+    first->setType(state->params.elemental.get());
     mol->AddAtom(first);  // add atom to ensure correctness of formula
   }
Index: src/Actions/AtomAction/ChangeElementAction.def
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/ChangeElementAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,9 @@
 typedef std::map<int, const element *> ElementMap;
 
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (const element *)
 #define paramtokens ("change-element")
@@ -18,4 +20,6 @@
 #undef paramdefaults
 #define paramreferences (elemental)
+#define paramvalids \
+(ElementValidator())
 
 #define statetypes (ElementMap)
Index: src/Actions/AtomAction/RemoveAction.def
===================================================================
--- src/Actions/AtomAction/RemoveAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/RemoveAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<AtomicInfo>)
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,17 +44,17 @@
 
   // check whether Axis is valid
-  if (params.Axis.IsZero())
+  if (params.Axis.get().IsZero())
     return Action::failure;
 
   // convert from degrees to radian
-  params.angle *= M_PI/180.;
+  double radian = params.angle.get() * M_PI/180.;
 
   // Creation Line that is the rotation axis
-  Line RotationAxis(Vector(0.,0.,0.), params.Axis);
+  Line RotationAxis(Vector(0.,0.,0.), params.Axis.get());
 
-  LOG(0, "Rotate around origin by " << params.angle << " radian, axis from origin to " << params.Axis << ".");
+  LOG(0, "Rotate around origin by " << radian << " radian, axis from origin to " << params.Axis.get() << ".");
   // TODO: use AtomSet::rotate?
   for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
-    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), params.angle));
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), radian));
   }
   LOG(0, "done.");
@@ -65,9 +65,12 @@
   AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
 
+  // convert from degrees to radian
+  double radian = params.angle.get() * M_PI/180.;
+
   // Creation Line that is the rotation axis
-  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis);
+  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis.get());
 
   for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
-    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), -state->params.angle));
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), -radian));
   }
 
@@ -78,9 +81,12 @@
   AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
 
+  // convert from degrees to radian
+  double radian = params.angle.get() * M_PI/180.;
+
   // Creation Line that is the rotation axis
-  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis);
+  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis.get());
 
   for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
-    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), state->params.angle));
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), radian));
   }
 
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.def
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,10 @@
 #include "LinearAlgebra/Vector.hpp"
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Specific/RotationAngleValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (double)(Vector)
 #define paramtokens ("rotate-around-origin")("position")
@@ -17,4 +20,7 @@
 #undef paramdefaults
 #define paramreferences (angle)(Axis)
+#define paramvalids \
+(RotationAngleValidator())\
+(DummyValidator< Vector> ())
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/AtomAction/SaveSelectedAtomsAction.cpp
===================================================================
--- src/Actions/AtomAction/SaveSelectedAtomsAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/SaveSelectedAtomsAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,17 +38,17 @@
 /** =========== define the function ====================== */
 Action::state_ptr AtomSaveSelectedAtomsAction::performCall() {
-  LOG(1, "Storing selected atoms to file " << params.filename << ".");
+  LOG(1, "Storing selected atoms to file " << params.filename.get() << ".");
 
   // extract suffix
   std::string FilenameSuffix;
   std::string FilenamePrefix;
-  if (params.filename.has_filename()) {
+  if (params.filename.get().has_filename()) {
     // get suffix
 #if BOOST_VERSION >= 104600
-      FilenameSuffix = params.filename.extension().string().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.stem().string();
+      FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
+      FilenamePrefix = params.filename.get().stem().string();
 #else
-      FilenameSuffix = params.filename.extension().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.stem();
+      FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
+      FilenamePrefix = params.filename.get().stem();
 #endif
   } else {
@@ -60,9 +60,9 @@
   // parse the file
   boost::filesystem::ofstream output;
-  output.open(params.filename);
+  output.open(params.filename.get());
   if (!output.fail()) {
     FormatParserStorage::getInstance().saveSelectedAtoms(output, FilenameSuffix);
   } else {
-    ELOG(1, "Could not open file " << params.filename << ".");
+    ELOG(1, "Could not open file " << params.filename.get() << ".");
   }
   output.close();
Index: src/Actions/AtomAction/SaveSelectedAtomsAction.def
===================================================================
--- src/Actions/AtomAction/SaveSelectedAtomsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/SaveSelectedAtomsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,11 @@
 
 
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)
 #define paramtokens ("save-selected-atoms")
@@ -17,4 +21,6 @@
 #undef paramdefaults
 #define paramreferences (filename)
+#define paramvalids \
+(!FilePresentValidator() && ParserFileValidator())
 
 #undef statetypes
Index: src/Actions/AtomAction/TranslateAction.cpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/TranslateAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,6 +44,6 @@
   // TODO: use AtomSet::translate
   for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
-    *(*iter) += params.x;
-    if (params.periodic)
+    *(*iter) += params.x.get();
+    if (params.periodic.get())
       (*iter)->setPosition(domain.enforceBoundaryConditions((*iter)->getPosition()));
   }
@@ -57,6 +57,6 @@
 
   for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
-    *(*iter) -= state->params.x;
-    if (state->params.periodic)
+    *(*iter) -= state->params.x.get();
+    if (state->params.periodic.get())
       (*iter)->setPosition(domain.enforceBoundaryConditions((*iter)->getPosition()));
   }
@@ -70,6 +70,6 @@
 
   for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
-    *(*iter) += state->params.x;
-    if (state->params.periodic)
+    *(*iter) += state->params.x.get();
+    if (state->params.periodic.get())
       (*iter)->setPosition(domain.enforceBoundaryConditions((*iter)->getPosition()));
   }
